package fr.inria.phoenix.diasuite.framework.context.parkingsuggestion;

import fr.inria.diagen.core.ServiceConfiguration;
import fr.inria.diagen.core.exception.InvocationException;
import fr.inria.diagen.core.network.RemoteServiceInfo;
import fr.inria.diagen.core.service.local.Service;
import fr.inria.diagen.core.service.proxy.Proxy;
import fr.inria.diagen.core.service.buffer.Buffer;
import java.util.HashMap;
import java.util.Map;
import fr.inria.diagen.core.network.DataDeliveryEnum;
import fr.inria.diagen.core.network.DataDeliveryModel;
import fr.inria.diagen.core.service.local.ServiceProperties;

import fr.inria.phoenix.diasuite.framework.context.parkingavailability.ParkingAvailabilityValue;

@SuppressWarnings("all")
public abstract class AbstractParkingSuggestion extends Service  {

	/**================== CLASS ATTRIBUTES ==================**/
	private java.util.List<fr.inria.phoenix.diasuite.framework.datatype.parkinglotenum.ParkingLotEnum> contextValue;
	
		private static final Map<String, Object> deliveryModels;
		
		static {
			deliveryModels = new HashMap<String, Object>();
			deliveryModels.put("ParkingAvailability",
						new DataDeliveryModel.Builder()
								.deliveryModel(DataDeliveryEnum.EVENT_DRIVEN)
								.build());
		}
	/*=======================================================*/
	
	
	/**================= CONTEXT CONSTRUCTOR ================**/
	public AbstractParkingSuggestion(ServiceConfiguration serviceConfiguration) {
		super("/Context/ParkingSuggestion/", serviceConfiguration);
		
		
	addToOutProperties(ServiceProperties.DELIVERY.toString(),
			deliveryModels);
	}
    /*=======================================================*/
    
    
    /**============== METHODS FOR CONTEXT VALUE =============**/
	// Code relative to the return value of the context        
	    
	    private void setParkingSuggestion(java.util.List<fr.inria.phoenix.diasuite.framework.datatype.parkinglotenum.ParkingLotEnum> newContextValue) {
	        contextValue = newContextValue;
	        getProcessor().publishValue(getOutProperties(), "ParkingSuggestion", newContextValue);
	    }
	    
	    /**
	     * Get the last value of the context
	     * 
	     * @return the latest value published by the context
	     */
	    protected final java.util.List<fr.inria.phoenix.diasuite.framework.datatype.parkinglotenum.ParkingLotEnum> getLastValue() {
	        return contextValue;
	    }
    /*=======================================================*/
    
    
    /**============ CONTEXT RETURN VALUE CLASS ==============**/
            // End of code relative to the return value of the context
    /*=======================================================*/
    
    /**============ INTERACTION CONTRACT METHOD =============**/
    protected abstract java.util.List<fr.inria.phoenix.diasuite.framework.datatype.parkinglotenum.ParkingLotEnum> onParkingAvailability(ParkingAvailabilityValue parkingAvailability, Discover discover);
    /*=======================================================*/
    
    /**============== DEVICE SUBSCRIPTION CODE ==============**/
    
    /*=======================================================*/
    
    /**================ DEVICE DISCOVERY CODE ===============**/
    
    // Discover object for ParkingAvailability
    /**
     * An object to discover devices and contexts for the following interaction contract:
     * 
     * <code>
     * 
     * </code>
     */
    protected final class Discover {
        private final fr.inria.diagen.core.service.filter.service.ServiceFilter parkingUsagePatternFilter = new fr.inria.diagen.core.service.filter.service.ServiceFilter("/Context/ParkingUsagePattern/");
        
        private RemoteServiceInfo getParkingUsagePatternRsi() {
            return getProcessor().discoverComponents(getOutProperties(), parkingUsagePatternFilter).get(0);
        }
        
        /**
         * Get the value of the <code>ParkingUsagePattern</code> context
         * 
         * @return the value of the <code>ParkingUsagePattern</code> context
         */
        public java.util.List<fr.inria.phoenix.diasuite.framework.datatype.usagepattern.UsagePattern> parkingUsagePattern() {
            return (java.util.List<fr.inria.phoenix.diasuite.framework.datatype.usagepattern.UsagePattern>) getProcessor().callGetValue(getOutProperties(), getParkingUsagePatternRsi(), "ParkingUsagePattern");
        }
    }
    // End of discover object for ParkingAvailability
    /*=======================================================*/
    
    /**=================== SERVICE METHODS ==================**/
    // Methods from the Service class
    @Override
    protected final void internalPostInitialize() {
    subscribeValue("ParkingAvailability", "/Context/ParkingAvailability/"); // subscribe to ParkingAvailability context
    	postInitialize();
    }
    	
    
    
        @Override
        public final void valueReceived(java.util.Map<String, Object> properties, RemoteServiceInfo source, String eventName, Object value, Object... indexes) {
        	
        	if (eventName.equals("ParkingAvailability") && source.isCompatible("/Context/ParkingAvailability/")) {
        	    ParkingAvailabilityValue parkingAvailabilityValue = new ParkingAvailabilityValue((java.util.List<fr.inria.phoenix.diasuite.framework.datatype.availability.Availability>) value);
        	    
        	    setParkingSuggestion(onParkingAvailability(parkingAvailabilityValue, new Discover()));
        	}
        }
        
    
    
    
    @Override
    public final Object getValueCalled(java.util.Map<String, Object> properties, RemoteServiceInfo source, String valueName,
            Object... indexes) throws Exception {
        if (valueName.equals("ParkingSuggestion")) {
            return getLastValue();
        }
        throw new InvocationException("Unsupported method call: " + valueName);
    }
    // End of methods from the Service class
    /*=======================================================*/
}
