package fr.inria.phoenix.diasuite.framework.datatype.presence;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

import org.apache.hadoop.io.BooleanWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.io.Writable;

public class PresenceWritable implements Writable {
	
	org.apache.hadoop.io.BooleanWritable presence;
	org.apache.hadoop.io.Text time;
	
	
	public PresenceWritable() {
		set(new BooleanWritable(),
		new Text());
	}

	public PresenceWritable(Boolean presence,
	String time) {
		set(new BooleanWritable(presence),
		new Text(time));
	}
	
	public PresenceWritable(Presence presence) {
		set(new BooleanWritable(presence.getPresence()),
		new Text(presence.getTime()));
	}

	private void set(BooleanWritable presence,
	Text time) {
		this.presence = presence;
		this.time = time;
	}
	
	public Presence get() {
		return new Presence(presence.get(),
		time.toString());
	}

	public org.apache.hadoop.io.BooleanWritable getPresence() {
		return this.presence;
	}
	public org.apache.hadoop.io.Text getTime() {
		return this.time;
	}

	@Override
	public void readFields(DataInput in) throws IOException {
		presence.readFields(in);
		time.readFields(in);
	}

	@Override
	public void write(DataOutput out) throws IOException {
		presence.write(out);
		time.write(out);
	}
}
