package fr.inria.phoenix.diasuite.framework.device.cityentrancepanel;

import fr.inria.diagen.core.ServiceConfiguration;
import fr.inria.diagen.core.exception.InvocationException;
import fr.inria.diagen.core.network.RemoteServiceInfo;
import fr.inria.diagen.core.service.local.Service;



public abstract class AbstractCityEntrancePanel extends Service {
    
    /**================= DEVICE ATTRIBUTES =================**/
    private java.lang.String _id;
    private fr.inria.phoenix.diasuite.framework.datatype.cityentranceenum.CityEntranceEnum _location;
    /*=======================================================*/
    
    
	/**=================== DEVICE SOURCES ==================**/
	
    /*=======================================================*/
	
    
	/**================= DEVICE CONSTRUCTOR ================**/
	
	public AbstractCityEntrancePanel(ServiceConfiguration serviceConfiguration,
	        java.lang.String idValue,
	        fr.inria.phoenix.diasuite.framework.datatype.cityentranceenum.CityEntranceEnum locationValue) {
	    super("/Device/DisplayPanel/CityEntrancePanel/", serviceConfiguration);
	    updateId(idValue);
	    updateLocation(locationValue);
		addToOutProperties("attributes", getAttributesCalled(null, null));
	}
	/*=======================================================*/
    
    
    /**=============== METHODS FOR ATTRIBUTES ==============**/
    
    protected void updateId(java.lang.String newIdValue) {
        if (_id != newIdValue) {
            _id = newIdValue;
            updateAttribute("id", newIdValue);
        }
    }
    
    public java.lang.String getId() {
        return _id;
    }		
    
    protected void updateLocation(fr.inria.phoenix.diasuite.framework.datatype.cityentranceenum.CityEntranceEnum newLocationValue) {
        if (_location != newLocationValue) {
            _location = newLocationValue;
            updateAttribute("location", newLocationValue);
        }
    }
    
    public fr.inria.phoenix.diasuite.framework.datatype.cityentranceenum.CityEntranceEnum getLocation() {
        return _location;
    }		
    /*=======================================================*/
    
    
    /**================ METHODS FOR SOURCES ================**/
    /*=======================================================*/
    
    
	/**================ METHODS FOR ACTIONS ================**/
    
    protected abstract void update(java.lang.String status) throws Exception;
    /*=======================================================*/
    
    
    /**================== SERVICE METHODS ==================**/
    @Override
    protected final void internalPostInitialize() {
        postInitialize();
    }
    
    @Override
    public final java.util.Map<String, Object> getAttributesCalled(java.util.Map<String, Object> properties, RemoteServiceInfo source) {
        java.util.Map<String, Object> attributes = new java.util.HashMap<String, Object>();
        attributes.put("id", _id);
        attributes.put("location", _location);
        	attributes.put("id", _id);
        return attributes;
    }	
    
    @SuppressWarnings("all")
    @Override
    public final Object invokeActionCalled(java.util.Map<String, Object> properties, RemoteServiceInfo source, String actionName, Object... args) throws Exception {
        if (actionName.equals("update")) {
            update((java.lang.String) args[0]);
            return null;
        }
        throw new InvocationException("Undefined action method name " + actionName);
    }
    
    @Override
    public Object getValueCalled(java.util.Map<String, Object> properties, RemoteServiceInfo source, String valueCalled, Object... args) throws Exception {
        if (valueCalled.equals("id")) {
            return _id;
        }
        if (valueCalled.equals("location")) {
            return _location;
        }
        	if (valueCalled.equals("_id")) {
        		return _id;
        	}
        throw new InvocationException("Undefined value " + valueCalled);
    }		
    /*=======================================================*/
}
