package fr.inria.phoenix.diasuite.framework.device.presencesensor;

import fr.inria.diagen.core.ServiceConfiguration;
import fr.inria.diagen.core.exception.InvocationException;
import fr.inria.diagen.core.network.RemoteServiceInfo;
import fr.inria.diagen.core.service.local.Service;

import fr.inria.phoenix.diasuite.framework.device.presencesensor.source.*;


public abstract class AbstractPresenceSensor extends Service {
    
    /**================= DEVICE ATTRIBUTES =================**/
    private java.lang.String _id;
    private fr.inria.phoenix.diasuite.framework.datatype.parkinglotenum.ParkingLotEnum _parkingLot;
    /*=======================================================*/
    
    
	/**=================== DEVICE SOURCES ==================**/
	private java.lang.Boolean _presence;
	
    /*=======================================================*/
	
    
	/**================= DEVICE CONSTRUCTOR ================**/
	
	public AbstractPresenceSensor(ServiceConfiguration serviceConfiguration,
	        java.lang.String idValue,
	        fr.inria.phoenix.diasuite.framework.datatype.parkinglotenum.ParkingLotEnum parkingLotValue) {
	    super("/Device/Device/PresenceSensor/", serviceConfiguration);
	    updateId(idValue);
	    updateParkingLot(parkingLotValue);
		addToOutProperties("attributes", getAttributesCalled(null, null));
	}
	/*=======================================================*/
    
    
    /**=============== METHODS FOR ATTRIBUTES ==============**/
    
    protected void updateId(java.lang.String newIdValue) {
        if (_id != newIdValue) {
            _id = newIdValue;
            updateAttribute("id", newIdValue);
        }
    }
    
    public java.lang.String getId() {
        return _id;
    }		
    
    protected void updateParkingLot(fr.inria.phoenix.diasuite.framework.datatype.parkinglotenum.ParkingLotEnum newParkingLotValue) {
        if (_parkingLot != newParkingLotValue) {
            _parkingLot = newParkingLotValue;
            updateAttribute("parkingLot", newParkingLotValue);
        }
    }
    
    public fr.inria.phoenix.diasuite.framework.datatype.parkinglotenum.ParkingLotEnum getParkingLot() {
        return _parkingLot;
    }		
    /*=======================================================*/
    
    
    /**================ METHODS FOR SOURCES ================**/
    
    protected void publishPresence(java.lang.Boolean newPresenceValue) {
    	_presence = newPresenceValue;
    	getProcessor().publishValue(getOutProperties(), "presence", newPresenceValue); 
    }
    
    protected java.lang.Boolean getPresence() throws Exception {
    	return _presence;
    }		
    /*=======================================================*/
    
    
	/**================ METHODS FOR ACTIONS ================**/
    /*=======================================================*/
    
    
    /**================== SERVICE METHODS ==================**/
    @Override
    protected final void internalPostInitialize() {
        postInitialize();
    }
    
    @Override
    public final java.util.Map<String, Object> getAttributesCalled(java.util.Map<String, Object> properties, RemoteServiceInfo source) {
        java.util.Map<String, Object> attributes = new java.util.HashMap<String, Object>();
        attributes.put("id", _id);
        attributes.put("parkingLot", _parkingLot);
        	attributes.put("id", _id);
        return attributes;
    }	
    
    @SuppressWarnings("all")
    @Override
    public final Object invokeActionCalled(java.util.Map<String, Object> properties, RemoteServiceInfo source, String actionName, Object... args) throws Exception {
        throw new InvocationException("Undefined action method name " + actionName);
    }
    
    @Override
    public Object getValueCalled(java.util.Map<String, Object> properties, RemoteServiceInfo source, String valueCalled, Object... args) throws Exception {
        if (valueCalled.equals("id")) {
            return _id;
        }
        if (valueCalled.equals("parkingLot")) {
            return _parkingLot;
        }
        	if (valueCalled.equals("_id")) {
        		return _id;
        	}
        if (valueCalled.equals("presence")) {
            return getPresence();
        }
        throw new InvocationException("Undefined value " + valueCalled);
    }		
    /*=======================================================*/
}
