package parkingmanager;

import parkingmanager.context.AverageOccupancy;
import parkingmanager.context.ParkingAvailability;
import parkingmanager.context.ParkingSuggestion;
import parkingmanager.context.ParkingUsagePattern;
import parkingmanager.controller.CityEntrancePanelController;
import parkingmanager.controller.MessengerController;
import parkingmanager.controller.ParkingEntrancePanelController;
import fr.inria.phoenix.diasuite.framework.context.averageoccupancy.AbstractAverageOccupancy;
import fr.inria.phoenix.diasuite.framework.context.parkingavailability.AbstractParkingAvailability;
import fr.inria.phoenix.diasuite.framework.context.parkingsuggestion.AbstractParkingSuggestion;
import fr.inria.phoenix.diasuite.framework.context.parkingusagepattern.AbstractParkingUsagePattern;
import fr.inria.phoenix.diasuite.framework.controller.cityentrancepanelcontroller.AbstractCityEntrancePanelController;
import fr.inria.phoenix.diasuite.framework.controller.messengercontroller.AbstractMessengerController;
import fr.inria.phoenix.diasuite.framework.controller.parkingentrancepanelcontroller.AbstractParkingEntrancePanelController;
import fr.inria.phoenix.diasuite.framework.deployment.AppComponentBinder;

public class ComponentBinder extends AppComponentBinder {

	/*********************** CONTEXTS **********************/

	@Override
	public Class<? extends AbstractParkingAvailability> getParkingAvailabilityClass() {
		// TODO Auto-generated method stub
		return ParkingAvailability.class;
	}

	@Override
	public Class<? extends AbstractParkingUsagePattern> getParkingUsagePatternClass() {
		// TODO Auto-generated method stub
		return ParkingUsagePattern.class;
	}

	@Override
	public Class<? extends AbstractAverageOccupancy> getAverageOccupancyClass() {
		// TODO Auto-generated method stub
		return AverageOccupancy.class;
	}

	@Override
	public Class<? extends AbstractParkingSuggestion> getParkingSuggestionClass() {
		// TODO Auto-generated method stub
		return ParkingSuggestion.class;
	}

	/*********************** CONTROLLERS **********************/

	@Override
	public Class<? extends AbstractParkingEntrancePanelController> getParkingEntrancePanelControllerClass() {
		// TODO Auto-generated method stub
		return ParkingEntrancePanelController.class;
	}

	@Override
	public Class<? extends AbstractCityEntrancePanelController> getCityEntrancePanelControllerClass() {
		// TODO Auto-generated method stub
		return CityEntrancePanelController.class;
	}

	@Override
	public Class<? extends AbstractMessengerController> getMessengerControllerClass() {
		// TODO Auto-generated method stub
		return MessengerController.class;
	}

}
