package parkingmanager.context;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.inria.diagen.core.ServiceConfiguration;
import fr.inria.phoenix.diasuite.framework.context.parkingavailability.ParkingAvailabilityValue;
import fr.inria.phoenix.diasuite.framework.context.parkingsuggestion.AbstractParkingSuggestion;
import fr.inria.phoenix.diasuite.framework.datatype.availability.Availability;
import fr.inria.phoenix.diasuite.framework.datatype.parkinglotenum.ParkingLotEnum;
import fr.inria.phoenix.diasuite.framework.datatype.usagepattern.UsagePattern;
import fr.inria.phoenix.diasuite.framework.datatype.usagepatternenum.UsagePatternEnum;

public class ParkingSuggestion extends AbstractParkingSuggestion {

	public ParkingSuggestion(ServiceConfiguration serviceConfiguration) {
		super(serviceConfiguration);
	}

	@Override
	protected List<ParkingLotEnum> onParkingAvailability(
			ParkingAvailabilityValue parkingAvailability, Discover discover) {

		List<ParkingLotEnum> parkingLotEnum = new ArrayList<ParkingLotEnum>();
		Map<ParkingLotEnum, UsagePatternEnum> parkingLotUsageMap = new HashMap<ParkingLotEnum, UsagePatternEnum>();
		Map<ParkingLotEnum, Integer> parkingLotAvailabilityMap = new HashMap<ParkingLotEnum, Integer>();

		for (Availability availability : parkingAvailability.value())
			parkingLotAvailabilityMap.put(availability.getParkingLot(),
					availability.getCount());

		for (UsagePattern usagePattern : discover.parkingUsagePattern())
			parkingLotUsageMap.put(usagePattern.getParkingLot(),
					usagePattern.getLevel());

		for (Entry<ParkingLotEnum, UsagePatternEnum> entry : parkingLotUsageMap
				.entrySet())
			if (!(entry.getValue().equals(UsagePatternEnum.HIGH)))
				if (parkingLotAvailabilityMap.get(entry.getKey()) > 50)
					parkingLotEnum.add(entry.getKey());

		return parkingLotEnum;
	}
}
