package parkingmanager.context;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import fr.inria.diagen.core.ServiceConfiguration;
import fr.inria.phoenix.diasuite.framework.context.parkingusagepattern.AbstractParkingUsagePattern;
import fr.inria.phoenix.diasuite.framework.datatype.parkinglotenum.ParkingLotEnum;
import fr.inria.phoenix.diasuite.framework.datatype.usagepattern.UsagePattern;
import fr.inria.phoenix.diasuite.framework.datatype.usagepatternenum.UsagePatternEnum;

public class ParkingUsagePattern extends AbstractParkingUsagePattern {

	private List<UsagePattern> parkingLotUsageList;

	public ParkingUsagePattern(ServiceConfiguration serviceConfiguration) {
		super(serviceConfiguration);
		parkingLotUsageList = new ArrayList<UsagePattern>();
	}

	@Override
	protected void onPeriodicPresenceFromPresenceSensor(
			Map<ParkingLotEnum, List<Boolean>> presenceByParkingLotMap) {

		List<UsagePattern> tmpList = new ArrayList<UsagePattern>();

		for (Map.Entry<ParkingLotEnum, List<Boolean>> parkingLot : presenceByParkingLotMap
				.entrySet()) {

			int sum = 0;
			for (Boolean presence : parkingLot.getValue())
				if (!presence)
					sum++;

			if (sum > 90)
				tmpList.add(new UsagePattern(parkingLot.getKey(),
						UsagePatternEnum.HIGH));
			else if (sum < 10)
				tmpList.add(new UsagePattern(parkingLot.getKey(),
						UsagePatternEnum.LOW));
			else
				tmpList.add(new UsagePattern(parkingLot.getKey(),
						UsagePatternEnum.MODERATE));

			parkingLotUsageList = tmpList;
		}
	}

	@Override
	protected List<UsagePattern> getValue() {
		return parkingLotUsageList;
	}

}
